; Z88 CamelForth
; romheader.asm (Application card header)

	defs	$3fc0-ASMPC

.front_dor	defb	0,0,0	; link to parent
	defb	0,0,0	; no help DOR
	defw	cam_dor	; first application DOR
	defb	in_bank
	defb	$13	; ROM front DOR
	defb	8	; length
	defb	'N'
	defb	5
	defm	"APPL"&0
	defb	$ff

; Package call fth_in, for registration of client applications
; (BYE deals with deregistration)

.call_in
	ld	hl,clients
	inc	(hl)		; increment # clients
	ld	a,(seg3)
	pop	hl
	pop	de
	ld	d,a		; change saved seg3 to our bank
	push	de
	and	a
	jp	(hl)

; This is the "entry point" pointed to from the CamelForth DOR ($ffe0)

	defs	$3fe0-ASMPC
.fake_entry
	jp	mainentry	; CamelForth entry point
.appenquiry
	ld	bc,(usr_hole+2)	; BC=HOLE start
	ld	de,(usr_hole)	; DE=HOLE end
	push	hl
	ld	h,d
	ld	l,e
	and	a
	sbc	hl,bc		; Test END=START
	pop	hl
	scf
	ret	z		; exit with Fc=1 if so (don't give any back)
	ccf
	ret			; else, exit with Fc=0

	defs	$3ff8-ASMPC

.eprom_header	defw	$4553	; card ID
	defb	@00000011	; UK country code
	defb	$80	; external application
IF CF_DEBUG
	defb	$02	; size of EPROM (32K)
ELSE
	defb	$01	; size of EPROM (16K)
ENDIF
	defb	0
	defm	"OZ"
